<template>
  <div>
    <div class="calendar-area">
      <div
        class="modal-wrapper"
        v-if="isModalShown"
        @click.self="closeModal"
      >
        <div class="modal">
          <div class="modal-inputs">
            <div class="modal-radio">
              <div>
                <input
                  type="radio"
                  id="changeWork"
                  name="work"
                  value="changeWork"
                  v-model="modalChoice"
                  checked
                >
                <label for="changeWork">Изменить день</label>
              </div>
              <div>
                <input
                  type="radio"
                  id="setTime"
                  name="work"
                  value="setTime"
                  v-model="modalChoice"
                >
                <label for="setTime">Добавить время</label>
              </div>
            </div>
            <div class="modal-fields"
                 v-if="modalChoice === 'setTime'">
              <input
                type="text"
                v-mask="{regex: '((1[0-9])||(2[0-4]))||(0[0-9])||([0-9])'}"
                v-model="modalTimeFrom"
              >
              <span> - </span>
              <input
                type="text"
                v-mask="{regex: '((1[0-9])||(2[0-4]))||(0[0-9])||([0-9])'}"
                v-model="modalTimeTo"
              >
            </div>
          </div>
          <button
            class="modal-submit"
            @click="submitModal"
          >
            Сохранить
          </button>
        </div>
      </div>
      <settings-modal
        :is-modal-shown="settingsModalShown"
        :settings="settings"
        :starting-date="startingDateNoOffset"
        @closeModal="closeSettings"
        @saveSettings="saveSettings"
      />
      <div class="days">
        <div v-for="(day, index) in dayName"
             :key='`${index}-day`'>
          {{ day }}
        </div>
      </div>
      <div v-if="loaded">
        <div class="calendar">
          <div class="hidden-calendar-cell"
               v-for="(cell, index) in getMonthStart"
               :key='`${index}-hidden`'>
          </div>
          <date-cell
            v-for="(cell, index) in getDaysInMonth"
            :key='`${index}-cell`'
            :starting-date="startingDateNoOffset"
            :altered-cells="alteredCells"
            :date="date"
            :cell-number="cell"
            :is-working="isWorking(cell)"
            @changeWorkingDay="showModal"/>
        </div>
      </div>
      <div v-else
           class="calendar">
        <img src="../assets/loading_icon.gif" alt="loading" class="loading"/>
      </div>
    </div>
    <div class="alterButtons" v-if="loaded">
      <label for="allowAlter" class="allowAlter">
        <input id="allowAlter" type="checkbox" v-model="allowAlter">
        <span>Разрешить изменение дней</span>
      </label>
      <button class="alteredDropButton"
              :disabled="!allowAlter"
              @click="dropAltered">
        Сбросить изменённые дни
      </button>
      <button class="settingsButton"
              @click="openSettings">
        Настройки
      </button>
      <select
        class="changeVkID"
        v-model="selectedVkID"
        v-if="isAdmin"
      >
        <option v-for="(user, index) in changingUsers"
                :key="index"
                :value="user.id">{{ `${user.name} ${user.lastAccess || ''}` }}
        </option>
      </select>
    </div>
  </div>
</template>

<script>
import moment from 'moment';
import connect from '@vkontakte/vkui-connect';
import bridge from '@vkontakte/vk-bridge';
import { collection, doc, onSnapshot } from 'firebase/firestore';
import ScheduleOfWorkService, { db } from '@/service/ScheduleOfWorkService';
import DateCell from './DateCell.vue';
import SettingsModal from './modals/settingsModal.vue';

export default {
  name: 'DateTable',
  components: {
    SettingsModal,
    DateCell,
  },
  data() {
    return {
      changingUsers: [],
      selectedVkID: '',
      primaryId: '',
      settingsModalShown: false,
      modalTimeFrom: '',
      modalTimeTo: '',
      startingDate: '',
      startingDateNoOffset: '2021-01-01',
      selectedDay: null,
      modalChoice: 'changeWork',
      isModalShown: false,
      loaded: false,
      allowAlter: false,
      settings: {},
      defaultSettings: {
        offset: 0,
        workingDays: 2,
        nonWorkingDays: 2,
      },
      alteredCells: {},
      unsub: {
        settings: () => {
        },
        alteredCells: () => {
        },
      },
    };
  },

  props: [
    'date',
  ],

  mounted() {
    // local dev
    // this.onMounted({ id: '100792884' });

    bridge.send('VKWebAppGetUserInfo')
      .then((data) => {
        if (data.id) {
          this.onMounted(data);
        }
      })
      .catch((error) => {
        console.error('error at VKWebAppGetUserInfo:', error);
      });
  },

  watch: {
    async selectedVkID() {
      if (this.isAdmin) {
        localStorage.selectedVkID = this.selectedVkID;
        this.unSubToAll();
        this.subscribeToID();
        await this.takeAlteredCells();
        await this.setSettings();
      }
    },
    'settings.offset': {
      handler() {
        this.changeStartingDate();
      },
      immediate: true,
    },
  },

  computed: {
    isAdmin() {
      return this.primaryId === '100792884';
    },

    id() {
      return this.selectedVkID || this.primaryId || 'no user ID';
    },

    dayName() {
      return [
        'пн',
        'вт',
        'ср',
        'чт',
        'пт',
        'сб',
        'вск',
      ];
    },

    getDaysInMonth() {
      return moment(this.date).daysInMonth();
    },

    getMonthStart() {
      return (moment(this.date).startOf('month').day() || 7) - 1;
    },
  },

  methods: {
    changeStartingDate() {
      this.startingDate = moment(this.startingDateNoOffset, 'YYYY-MM-DD').add(this.settings.offset, 'days').format('YYYY-MM-DD');
      this.$emit('changeStartingDate', this.startingDate);
    },

    onMounted(data) {
      this.primaryId = String(data.id);
      ScheduleOfWorkService.setUser(this.id, { name: `${data.first_name} ${data.last_name}`, id: this.id, lastAccess: moment().format('DD.MM.YYYY HH:mm') });
      if (this.isAdmin) {
        this.selectedVkID = localStorage.selectedVkID || this.id;
        onSnapshot(collection(db, 'users'), this.setAllUsers);
      }
      this.subscribeToID();
    },

    async setAllUsers() {
      this.changingUsers = await ScheduleOfWorkService.getAllUsers();
    },

    subscribeToID() {
      this.unsub.settings = onSnapshot(doc(db, this.id, 'settings'), this.setSettings);
      this.unsub.alteredCells = onSnapshot(doc(db, this.id, 'alteredCells'), this.takeAlteredCells);
    },

    unSubToAll() {
      this.unsub.settings();
      this.unsub.alteredCells();
    },

    async openSettings() {
      await this.setSettings();
      this.settingsModalShown = true;
    },

    closeSettings() {
      this.settingsModalShown = false;
    },

    saveSettings(settings) {
      ScheduleOfWorkService.setSettings(this.id, settings);
      this.settings = { ...this.defaultSettings, ...settings };
    },

    async setSettings() {
      const settings = await ScheduleOfWorkService.getSettings(this.id);
      this.settings = {
        ...this.defaultSettings,
        ...settings,
      };
    },

    closeModal() {
      this.isModalShown = false;
    },

    onInput(value) {
      if (!+this[value]) {
        this[value] = '';
      }
    },

    showModal(day) {
      if (this.allowAlter) {
        this.selectedDay = day;
        // eslint-disable-next-line max-len,eqeqeq
        if (Object.keys(this.alteredCells).findIndex((el) => Number(el) === this.getAmountOfDays(this.selectedDay)) === -1) {
          this.isModalShown = true;
          this.modalChoice = 'changeWork';
          this.modalTimeTo = '';
          this.modalTimeFrom = '';
        } else {
          delete this.alteredCells[this.getAmountOfDays(this.selectedDay)];
        }
        this.writeCells();
      }
    },

    submitModal() {
      if (this.modalChoice === 'setTime') {
        if (this.modalTimeTo && this.modalTimeFrom) {
          this.changeWorkingDay(this.selectedDay);
          this.isModalShown = false;
        }
        return;
      }
      this.changeWorkingDay(this.selectedDay);
      this.isModalShown = false;
    },

    changeWorkingDay(day) {
      let time = '';
      let state = !this.isWorking(day) ? 'working-altered' : 'not-working-altered';
      if (this.modalChoice === 'setTime') {
        const modalTimeFrom = this.modalTimeFrom.match(/\d*/)[0];
        const modalTimeTo = this.modalTimeTo.match(/\d*/)[0];
        time = `${modalTimeFrom.length === 1 ? `0${modalTimeFrom}` : modalTimeFrom}-${modalTimeTo.length === 1 ? `0${modalTimeTo}` : modalTimeTo}`;
        state = 'half-altered';
      }
      this.alteredCells[this.getAmountOfDays(day)] = {
        state,
        time,
      };
      this.writeCells();
    },

    writeCells() {
      this.postCells(this.alteredCells);
    },

    async takeAlteredCells() {
      this.alteredCells = await this.getCells();
      this.loaded = true;
      connect.send('VKWebAppInit', {});
    },

    dropAltered() {
      if (this.allowAlter) {
        Object.keys(this.alteredCells).forEach((key) => {
          if (Number(key) >= this.getAmountOfDays(1)
            && Number(key) <= this.getAmountOfDays(this.getDaysInMonth)) {
            delete this.alteredCells[key];
          }
        });
        this.postCells(this.alteredCells);
      }
    },

    getAmountOfDays(day, isOffset) {
      const date = `${moment(this.date).format('YYYY-MM')}-${day}`;
      return moment(date, 'YYYY-MM-DD').diff(isOffset ? this.startingDate : this.startingDateNoOffset, 'days') + 1;
    },

    isWorking(day) {
      // eslint-disable-next-line max-len
      const remainingDays = this.getAmountOfDays(day, true) % (this.settings.workingDays + this.settings.nonWorkingDays);
      if (remainingDays > 0) {
        if (this.settings.workingDays < remainingDays) {
          return true;
        }
        return false;
      }
      return true;
    },

    async postCells(alteredCells) {
      await ScheduleOfWorkService.setAlteredCells(this.id, alteredCells);
    },

    async getCells() {
      const response = await ScheduleOfWorkService.getAlteredCells(this.id);
      return response || {};
    },
  },
};
</script>
